Attribute VB_Name = "SaveScreen"

      '--------------------------------------------------------------------
      ' Compatible Win16 et Win32 (VB4 & VB5)
      '
      ' ce module contient plusieurs routines pour capturer des fenetres
      ' dans une image.
      '
      '
      '
      ' CreateBitmapPicture - crer une image depuis une bitmap et une  palette
      ' CaptureWindow - Capturer un fenetre a partir de son handle
      ' CaptureActiveWindow - Capture la fenetre active
      ' CaptureForm - Capture la form entiere
      ' CaptureClient - Capture la zone client de la form
      ' CaptureScreen - Capturer l'ecran complet
      ' PrintPictureToFitPage - imprimer les images  leurs tailles maxi
      '
      '
      ' NOTES
      '    - Aucun traitements des erreur n'est inclus dans ces routines
      '--------------------------------------------------------------------
      '
      Option Explicit
      Option Base 0

      Private Type PALETTEENTRY
         peRed As Byte
         peGreen As Byte
         peBlue As Byte
         peFlags As Byte
      End Type

      Private Type LOGPALETTE
         palVersion As Integer
         palNumEntries As Integer
         palPalEntry(255) As PALETTEENTRY  ' assez pour 256 couleurs
      End Type

      Private Type GUID
         Data1 As Long
         Data2 As Integer
         Data3 As Integer
         Data4(7) As Byte
      End Type
    '------------------------------------------------------------------------
    '
    ' Windows 95 et NT API
    '
    '------------------------------------------------------------------------
      #If Win32 Then

         Private Const RASTERCAPS As Long = 38
         Private Const RC_PALETTE As Long = &H100
         Private Const SIZEPALETTE As Long = 104

         Private Type RECT
            Left As Long
            Top As Long
            Right As Long
            Bottom As Long
         End Type

         Private Declare Function CreateCompatibleDC Lib "GDI32" ( _
            ByVal hDC As Long) As Long
         Private Declare Function CreateCompatibleBitmap Lib "GDI32" ( _
            ByVal hDC As Long, ByVal nWidth As Long, _
            ByVal nHeight As Long) As Long
         Private Declare Function GetDeviceCaps Lib "GDI32" ( _
            ByVal hDC As Long, ByVal iCapabilitiy As Long) As Long
         Private Declare Function GetSystemPaletteEntries Lib "GDI32" ( _
            ByVal hDC As Long, ByVal wStartIndex As Long, _
            ByVal wNumEntries As Long, lpPaletteEntries As PALETTEENTRY) _
            As Long
         Private Declare Function CreatePalette Lib "GDI32" ( _
            lpLogPalette As LOGPALETTE) As Long
         Private Declare Function SelectObject Lib "GDI32" ( _
            ByVal hDC As Long, ByVal hObject As Long) As Long
         Private Declare Function BitBlt Lib "GDI32" ( _
            ByVal hDCDest As Long, ByVal XDest As Long, _
            ByVal YDest As Long, ByVal nWidth As Long, _
            ByVal nHeight As Long, ByVal hDCSrc As Long, _
            ByVal XSrc As Long, ByVal YSrc As Long, ByVal dwRop As Long) _
            As Long
         Private Declare Function DeleteDC Lib "GDI32" ( _
            ByVal hDC As Long) As Long
         Private Declare Function GetForegroundWindow Lib "USER32" () _
            As Long
         Private Declare Function SelectPalette Lib "GDI32" ( _
            ByVal hDC As Long, ByVal hPalette As Long, _
            ByVal bForceBackground As Long) As Long
         Private Declare Function RealizePalette Lib "GDI32" ( _
            ByVal hDC As Long) As Long
         Private Declare Function GetWindowDC Lib "USER32" ( _
            ByVal hWnd As Long) As Long
         Private Declare Function GetDC Lib "USER32" ( _
            ByVal hWnd As Long) As Long
         Private Declare Function GetWindowRect Lib "USER32" ( _
            ByVal hWnd As Long, lpRect As RECT) As Long
         Private Declare Function ReleaseDC Lib "USER32" ( _
            ByVal hWnd As Long, ByVal hDC As Long) As Long
         Private Declare Function GetDesktopWindow Lib "USER32" () As Long

         Private Type PicBmp
            Size As Long
            Type As Long
            hBmp As Long
            hPal As Long
            Reserved As Long
         End Type

         Private Declare Function OleCreatePictureIndirect _
            Lib "olepro32.dll" (PicDesc As PicBmp, RefIID As GUID, _
            ByVal fPictureOwnsHandle As Long, IPic As IPicture) As Long
    '------------------------------------------------------------------------
    '
    ' Windows 3.11 API
    '
    '------------------------------------------------------------------------

      #ElseIf Win16 Then

         Private Const RASTERCAPS As Integer = 38
         Private Const RC_PALETTE As Integer = &H100
         Private Const SIZEPALETTE As Integer = 104

         Private Type RECT
            Left As Integer
            Top As Integer
            Right As Integer
            Bottom As Integer
         End Type

         Private Declare Function CreateCompatibleDC Lib "GDI" ( _
            ByVal hDC As Integer) As Integer
         Private Declare Function CreateCompatibleBitmap Lib "GDI" ( _
            ByVal hDC As Integer, ByVal nWidth As Integer, _
            ByVal nHeight As Integer) As Integer
         Private Declare Function GetDeviceCaps Lib "GDI" ( _
            ByVal hDC As Integer, ByVal iCapabilitiy As Integer) As Integer
         Private Declare Function GetSystemPaletteEntries Lib "GDI" ( _
            ByVal hDC As Integer, ByVal wStartIndex As Integer, _
            ByVal wNumEntries As Integer, _
            lpPaletteEntries As PALETTEENTRY) As Integer
         Private Declare Function CreatePalette Lib "GDI" ( _
            lpLogPalette As LOGPALETTE) As Integer
         Private Declare Function SelectObject Lib "GDI" ( _
            ByVal hDC As Integer, ByVal hObject As Integer) As Integer
         Private Declare Function BitBlt Lib "GDI" ( _
            ByVal hDCDest As Integer, ByVal XDest As Integer, _
            ByVal YDest As Integer, ByVal nWidth As Integer, _
            ByVal nHeight As Integer, ByVal hDCSrc As Integer, _
            ByVal XSrc As Integer, ByVal YSrc As Integer, _
            ByVal dwRop As Long) As Integer
         Private Declare Function DeleteDC Lib "GDI" ( _
            ByVal hDC As Integer) As Integer
         Private Declare Function GetForegroundWindow Lib "USER" _
            Alias "GetActiveWindow" () As Integer
         Private Declare Function SelectPalette Lib "USER" ( _
            ByVal hDC As Integer, ByVal hPalette As Integer, ByVal _
            bForceBackground As Integer) As Integer
         Private Declare Function RealizePalette Lib "USER" ( _
            ByVal hDC As Integer) As Integer
         Private Declare Function GetWindowDC Lib "USER" ( _
            ByVal hWnd As Integer) As Integer
         Private Declare Function GetDC Lib "USER" ( _
            ByVal hWnd As Integer) As Integer
         Private Declare Function GetWindowRect Lib "USER" ( _
            ByVal hWnd As Integer, lpRect As RECT) As Integer
         Private Declare Function ReleaseDC Lib "USER" ( _
            ByVal hWnd As Integer, ByVal hDC As Integer) As Integer
         Private Declare Function GetDesktopWindow Lib "USER" () As Integer

         Private Type PicBmp
            Size As Integer
            Type As Integer
            hBmp As Integer
            hPal As Integer
            Reserved As Integer
         End Type

         Private Declare Function OleCreatePictureIndirect _
            Lib "oc25.dll" (PictDesc As PicBmp, RefIID As GUID, _
            ByVal fPictureOwnsHandle As Integer, IPic As IPicture) _
            As Integer

      #End If

      '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
      '
      ' CreateBitmapPicture
      '    - Crer un objet bitmap depuis une image bitmap et une palette
      '
      ' hBmp
      '    - Handle d'une bitmap
      '
      ' hPal
      '    - Handle d'une Palette
      '    - Peut tre null si la bitmap n'utilise pas de palette
      '
      ' Resultat
      '    - Un objet picture qui comtient la bitmap
      '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
      '
      #If Win32 Then
         Public Function CreateBitmapPicture(ByVal hBmp As Long, _
            ByVal hPal As Long) As Picture

            Dim r As Long
      #ElseIf Win16 Then
         Public Function CreateBitmapPicture(ByVal hBmp As Integer, _
            ByVal hPal As Integer) As Picture

            Dim r As Integer
      #End If
         Dim Pic As PicBmp
         ' IPicture a besoin d'une reference a un "Standard OLE Types"
         Dim IPic As IPicture
         Dim IID_IDispatch As GUID

         ' Renseigner le ID de l'Interface IDispatch
         With IID_IDispatch
            .Data1 = &H20400
            .Data4(0) = &HC0
            .Data4(7) = &H46
         End With

         ' Renseigner Pic
         With Pic
            .Size = Len(Pic)          ' longueur de la structure
            .Type = vbPicTypeBitmap   ' Type de Picture (bitmap)
            .hBmp = hBmp              ' Handle du bitmap
            .hPal = hPal              ' Handle de la palette (peut trenull)
         End With

         ' crer un Picture object
         r = OleCreatePictureIndirect(Pic, IID_IDispatch, 1, IPic)

         ' retourner un nouveau objet Picture
         Set CreateBitmapPicture = IPic
      End Function

      '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
      '
      ' CaptureWindow
      '    - Capturer une fenetre
      '
      ' hWndSrc
      '    - Handle de la fenetre  capturer
      '
      ' Client
      '    - si True CaptureWindow capture la zone client de la fenetre
      '    - si False CaptureWindow capture la fenetre entiere
      '
      ' LeftSrc, TopSrc, WidthSrc, HeightSrc
      '    - determine la portion de la fenetre  capturer
      '    - Dimensions en pixels
      '
      ' Retour
      '    - Retourne un objet Picture qui contient une bitmap de la zone de
      '      la fenetre  capturer
      '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
      #If Win32 Then
         Public Function CaptureWindow(ByVal hWndSrc As Long, _
            ByVal Client As Boolean, ByVal LeftSrc As Long, _
            ByVal TopSrc As Long, ByVal WidthSrc As Long, _
            ByVal HeightSrc As Long) As Picture

            Dim hDCMemory As Long
            Dim hBmp As Long
            Dim hBmpPrev As Long
            Dim r As Long
            Dim hDCSrc As Long
            Dim hPal As Long
            Dim hPalPrev As Long
            Dim RasterCapsScrn As Long
            Dim HasPaletteScrn As Long
            Dim PaletteSizeScrn As Long
      #ElseIf Win16 Then
         Public Function CaptureWindow(ByVal hWndSrc As Integer, _
            ByVal Client As Boolean, ByVal LeftSrc As Integer, _
            ByVal TopSrc As Integer, ByVal WidthSrc As Long, _
            ByVal HeightSrc As Long) As Picture

            Dim hDCMemory As Integer
            Dim hBmp As Integer
            Dim hBmpPrev As Integer
            Dim r As Integer
            Dim hDCSrc As Integer
            Dim hPal As Integer
            Dim hPalPrev As Integer
            Dim RasterCapsScrn As Integer
            Dim HasPaletteScrn As Integer
            Dim PaletteSizeScrn As Integer
      #End If
         Dim LogPal As LOGPALETTE

         ' traitement du device context
         If Client Then
            hDCSrc = GetDC(hWndSrc) ' device context pour la zone client
         Else
            hDCSrc = GetWindowDC(hWndSrc) ' device context pour la fenetre entiere
         End If

         ' crer un memory device context pour la copie
         hDCMemory = CreateCompatibleDC(hDCSrc)
         ' crer une bitmap et la mettre dans le memory DC
         hBmp = CreateCompatibleBitmap(hDCSrc, WidthSrc, HeightSrc)
         hBmpPrev = SelectObject(hDCMemory, hBmp)

         ' capturer les proprits de l'ecran
         RasterCapsScrn = GetDeviceCaps(hDCSrc, RASTERCAPS)
         HasPaletteScrn = RasterCapsScrn And RC_PALETTE
         PaletteSizeScrn = GetDeviceCaps(hDCSrc, SIZEPALETTE)

         ' si l'ecran a une palette faire une copie et la liberer
         If HasPaletteScrn And (PaletteSizeScrn = 256) Then
            ' faire une copie de la palette
            LogPal.palVersion = &H300
            LogPal.palNumEntries = 256
            r = GetSystemPaletteEntries(hDCSrc, 0, 256, _
                LogPal.palPalEntry(0))
            hPal = CreatePalette(LogPal)
            ' liberer la palette
            hPalPrev = SelectPalette(hDCMemory, hPal, 0)
            r = RealizePalette(hDCMemory)
         End If

         ' copier l'image de l'ecran dans le memory DC
         r = BitBlt(hDCMemory, 0, 0, WidthSrc, HeightSrc, hDCSrc, _
            LeftSrc, TopSrc, vbSrcCopy)

         hBmp = SelectObject(hDCMemory, hBmpPrev)

         ' si l'ecran avait une palette la restaurer
         If HasPaletteScrn And (PaletteSizeScrn = 256) Then
            hPal = SelectPalette(hDCMemory, hPalPrev, 0)
         End If

         ' liberer le device context
         r = DeleteDC(hDCMemory)
         r = ReleaseDC(hWndSrc, hDCSrc)

         ' appeler CreateBitmapPicturepour creer un objet image  partir des handles
         ' bitmap et palette et retourner l'objet picture

         Set CaptureWindow = CreateBitmapPicture(hBmp, hPal)
      End Function

      '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
      '
      ' CaptureScreen
      '    - Capturer l'ecran entier
      '
      ' Retour
      '    - Retourne un objet Picture qui contient une bitmap de l'ecran
      '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
      '
      Public Function CaptureScreen() As Picture
         #If Win32 Then
            Dim hWndScreen As Long
         #ElseIf Win16 Then
            Dim hWndScreen As Integer
         #End If

         ' handle de la fenetre desktop
         hWndScreen = GetDesktopWindow()

         ' Appeler CaptureWindow pour capturer la fenetre desktop entiere
         ' donner le handle et recuperer un objet picture

         Set CaptureScreen = CaptureWindow(hWndScreen, False, 0, 0, _
            Screen.Width \ Screen.TwipsPerPixelX, _
            Screen.Height \ Screen.TwipsPerPixelY)
      End Function

      '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
      '
      ' CaptureForm
      '    - Capturer la form entiere
      '
      ' frmSrc
      '    - l'objet Form  capturer
      '
      ' Retour
      '    - Retourne un objet Picture qui contient une bitmap de la form entiere      form
      '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
      Public Function CaptureForm(frmSrc As Form) As Picture
         ' appeler CaptureWindow pour capturer la form entiere
         ' donner son handle et recuperer l'objet picture
         Set CaptureForm = CaptureWindow(frmSrc.hWnd, False, 0, 0, _
            frmSrc.ScaleX(frmSrc.Width, vbTwips, vbPixels), _
            frmSrc.ScaleY(frmSrc.Height, vbTwips, vbPixels))
      End Function

      '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
      '
      ' CaptureClient
      '    - Capturer la zone client d'une Form
      '
      ' frmSrc
      '    - l'objet Form  capturer
      '
      ' Returns
      '    - Retourne un objet Picture qui contient une bitmap de la
      '      zone client de la form
      '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

      Public Function CaptureClient(frmSrc As Form) As Picture
         ' appeler CaptureWindow pour capturer la form entiere
         ' donner son handle et recuperer l'objet picture
         Set CaptureClient = CaptureWindow(frmSrc.hWnd, True, 0, 0, _
            frmSrc.ScaleX(frmSrc.ScaleWidth, frmSrc.ScaleMode, vbPixels), _
            frmSrc.ScaleY(frmSrc.ScaleHeight, frmSrc.ScaleMode, vbPixels))
      End Function

      '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
      '
      ' CaptureActiveWindow
      '    - Capturer la fenetre active
      '
      ' Retour
      '    - Retourne un objet Picture qui contient une bitmap de la fenetre
      '      active
      '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
      '
      Public Function CaptureActiveWindow() As Picture
         #If Win32 Then
            Dim hWndActive As Long
            Dim r As Long
         #ElseIf Win16 Then
            Dim hWndActive As Integer
            Dim r As Integer
         #End If
         Dim RectActive As RECT

         '  handle de la fenetre active
         hWndActive = GetForegroundWindow()

         ' dimensions de la fenetre
         r = GetWindowRect(hWndActive, RectActive)

         ' appeler CaptureWindow pour capturer la form entiere
         ' donner son handle et recuperer l'objet picture
      Set CaptureActiveWindow = CaptureWindow(hWndActive, False, 0, 0, _
            RectActive.Right - RectActive.Left, _
            RectActive.Bottom - RectActive.Top)
      End Function

      '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
      '
      ' PrintPictureToFitPage
      '    - Imprimer un objet Picture  aussi grand que possible
      '
      ' Prn
      '    - Objet printer de destination
      '
      ' Pic
      '    - Objet Picture
      '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
      '
      Public Sub PrintPictureToFitPage(Prn As Printer, Pic As Picture)
         Const vbHiMetric As Integer = 8
         Dim PicRatio As Double
         Dim PrnWidth As Double
         Dim PrnHeight As Double
         Dim PrnRatio As Double
         Dim PrnPicWidth As Double
         Dim PrnPicHeight As Double

         ' Determine si la  picture doit tre imprim en paysage ou portrait
         ' et positionne l'orientation
         If Pic.Height >= Pic.Width Then
            Prn.Orientation = vbPRORPortrait
         Else
            Prn.Orientation = vbPRORLandscape
         End If

         ' calculer les proportion de la picture
         PicRatio = Pic.Width / Pic.Height

         ' Calculer les dimensions de la zone imprimable en HiMetric
         PrnWidth = Prn.ScaleX(Prn.ScaleWidth, Prn.ScaleMode, vbHiMetric)
         PrnHeight = Prn.ScaleY(Prn.ScaleHeight, Prn.ScaleMode, vbHiMetric)
         ' Calculer les proportions pour l'imprimante
         PrnRatio = PrnWidth / PrnHeight

         ' Mettre la sortie  l'echelle
         If PicRatio >= PrnRatio Then
            ' dimension pour une picture en full width
            PrnPicWidth = Prn.ScaleX(PrnWidth, vbHiMetric, Prn.ScaleMode)
            PrnPicHeight = Prn.ScaleY(PrnWidth / PicRatio, vbHiMetric, _
               Prn.ScaleMode)
         Else
            ' dimension pour une picture en full height
            PrnPicHeight = Prn.ScaleY(PrnHeight, vbHiMetric, Prn.ScaleMode)
            PrnPicWidth = Prn.ScaleX(PrnHeight * PicRatio, vbHiMetric, _
               Prn.ScaleMode)
         End If

         ' Imprimer la picture avec la mthode PaintPicture
         Prn.PaintPicture Pic, 0, 0, PrnPicWidth, PrnPicHeight
      End Sub
      '--------------------------------------------------------------------




